fv::Reduce< T > Class Template Reference

Reduce a Value of type vector<T> to just a T. More...

`#include <value.hpp>`

Inheritance diagram for fv::Reduce< T >:
[legend]
Collaboration diagram for fv::Reduce< T >:
[legend]

## Public Member Functions

| Reduce (Function< T(std::vector< T >)> &reduce_fn, Value< std::vector< T > > *v, const std::string alias)
Public Member Functions inherited from fv::DerivedValue< T >
| DerivedValue (const std::string &name, const std::string &alias="")
void | log ()
T & | get_value ()
| Calculate, if necessary, and return the value held by this object.
Public Member Functions inherited from fv::Value< T >
| Value (const std::string &name, const std::string &alias="")
void | enable_logging (const std::function< std::string(T)> &value_to_string=[](T){return "";})
void | disable_logging ()

## Static Public Member Functions

static std::string | fmt_name (Function< T(std::vector< T >)> &reduce_fn, Value< std::vector< T >> *v)

## Protected Attributes

Value< std::vector< T > > * | v
Protected Attributes inherited from fv::DerivedValue< T >
T | value
Protected Attributes inherited from fv::Value< T >
std::function< std::string(T)> | value_to_string

## Private Member Functions

void | update_value ()
| Updates the internal value. More...

## Private Attributes

Function< T(std::vector< T >)> & | reduce_fn

## Additional Inherited Members

## Detailed Description

### template<typename T>
class fv::Reduce< T >

Reduce a Value of type vector<T> to just a T.

This is useful functionality to model, for instance, calculating the maximum element of a vector, or a the mean. See child classes for specific implementations.

Definition at line 951 of file value.hpp.

## Member Function Documentation

## update_value()

template<typename T>

void fv::Reduce< T >::update_value | ( |  | ) |

inlineprivatevirtual

Updates the internal value.

This function should be overridden by any child class to do the actual work of updating value based on whatever rules the class chooses. Normally, this consists of geting the values from some associated Value objects, doing some calculation on them, and storing the result in value.

Implements fv::DerivedValue< T >.

Definition at line 955 of file value.hpp.

The documentation for this class was generated from the following file:

- /home/caleb/Sources/TTTT/filval/value.hpp